<template>
  <div>
    <v-data-table
      :headers="headers"
      :items="tableSalesResult"
      hide-actions
      style="display:block;height:400px !important; overflow-y: auto;background:transparent">
      <template slot="items"
        slot-scope="props">
        <td>
          {{ props.item.name }}
        </td>
        <td class="text-xs-left">
          {{ props.item.number }}
        </td>
        <td class="text-xs-left">
          {{ props.item.salesPrice }}
        </td>
        <td class="text-xs-left">
          {{ props.item.totalSold }}
        </td>
      </template>
    </v-data-table>
  </div>
</template>
<script>
export default {
  name: 'SalesResultTable',
  data: () => ({
    headers: [
      {
        text: 'Product name',
        align: 'left',
        sortable: false,
        value: 'name'
      },
      { text: 'Number', value: 'number', sortable: false },
      { text: 'Cost', value: 'salesPrice', sortable: false },
      { text: 'Total', value: 'totalSold', sortable: false }
    ]
  }),
  computed: {
    salesResult () {
      return this.$store.state.reportModule.salesReportData
    },
    tableSalesResult () {
      let salesResportData = this.$store.state.reportModule.salesReportData
      let tableSalesResult = []
      let brandsList = []
      salesResportData.forEach(element => {
        brandsList.push(element.name)
      })
      let filteredBrandList = brandsList.filter(function (item, pos) {
        return brandsList.indexOf(item) === pos
      })
      filteredBrandList.forEach(element => {
        let singleElement = {}
        salesResportData.forEach(salesElement => {
          if (salesElement.name === element) {
            if (singleElement.number === undefined) {
              singleElement = {
                name: element,
                salesPrice: salesElement.salesPrice,
                totalSold: salesElement.salesPrice,
                number: 1
              }
            } else {
              singleElement.number = singleElement.number + 1
              singleElement.totalSold = singleElement.totalSold + salesElement.salesPrice
            }
          }
        })
        tableSalesResult.push(singleElement)
      })
      return tableSalesResult
    }
  }
}
</script>
